#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "SenseBoxMCU.h"
#include <SD.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);
File dataFileDaten;
GPS gps;
float date;
float time;
HDC1080 hdc;
BMP280 bmp_sensor;
Lightsensor lightsensor;
VEML6070 veml;
float latitude;
float longitude;
float height;
float speed;


  void printOnDisplay(String title1, String measurement1, String unit1, String title2, String measurement2, String unit2) {

    display.setCursor(0, 0);
    display.setTextSize(1);
    display.setTextColor(WHITE, BLACK);
    display.println(title1);
    display.setCursor(0, 10);
    display.setTextSize(2);
    display.print(measurement1);
    display.print(" ");
    display.setTextSize(1);
    display.println(unit1);
    display.setCursor(0, 30);
    display.setTextSize(1);
    display.println(title2);
    display.setCursor(0, 40);
    display.setTextSize(2);
    display.print(measurement2);
    display.print(" ");
    display.setTextSize(1);
    display.println(unit2);
  }



void setup() {
  senseBoxIO.powerI2C(true);
delay(2000);
display.begin(SSD1306_SWITCHCAPVCC, 0x3D);
display.display();
delay(100);
display.clearDisplay();
  SD.begin(28);
  dataFileDaten = SD.open("Daten.txt", FILE_WRITE);
dataFileDaten.close();

  gps.begin();
  hdc.begin();
  bmp_sensor.begin();
  lightsensor.begin();
  veml.begin();

  dataFileDaten = SD.open("Daten.txt", FILE_WRITE);
    dataFileDaten.println("Zeit, Temp, Feucht, Druck, Temp, Lux, UV, Hoehe, Breite, Laenge, Hoehe, kmh ");
    dataFileDaten.print(date);
    dataFileDaten.println(" IKARUS");
    dataFileDaten.println("");
  dataFileDaten.close();

}

void loop() {

gps.getGPS();
date = gps.getDate();
 time = gps.getTime();
latitude = gps.getLatitude();
longitude = gps.getLongitude();
height = gps.getAltitude();
speed = gps.getSpeed();
dataFileDaten = SD.open("Daten.txt", FILE_WRITE);
    dataFileDaten.print(time);
    dataFileDaten.print(", ");
    dataFileDaten.print(hdc.getTemperature());
    dataFileDaten.print(", ");
    dataFileDaten.print(hdc.getHumidity());
    dataFileDaten.print(", ");
    dataFileDaten.print(bmp_sensor.getPressure());
    dataFileDaten.print(", ");
    dataFileDaten.print(bmp_sensor.getTemperature());
    dataFileDaten.print(", ");
    dataFileDaten.print(lightsensor.getIlluminance());
    dataFileDaten.print(", ");
    dataFileDaten.print(veml.getUvIntensity());
    dataFileDaten.print(", ");
    dataFileDaten.print(bmp_sensor.getAltitude(1013));
    dataFileDaten.print(", ");
    dataFileDaten.print(latitude);
    dataFileDaten.print(", ");
    dataFileDaten.print(longitude);
    dataFileDaten.print(", ");
    dataFileDaten.print(height);
    dataFileDaten.print(", ");
    dataFileDaten.println(speed);
  dataFileDaten.close();
     printOnDisplay("Feuchtigkeit", String(hdc.getHumidity()), "%", "Hoehe", String(bmp_sensor.getAltitude(1013)), "m");
  display.display();
  display.clearDisplay();
  delay(1000);

}